﻿# Credits for this code go to Vadim Sterkin
# His original post https://www.outsidethebox.ms/21844/
# It is slightly modified by Sergey Tkachenko
# For this tutorial: https://winaero.com/how-to-disable-user-folder-backup-to-onedrive/

if (-Not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] 'Administrator')) {
    Write-Host "Insufficient privileges. Run this script as administrator." -ForegroundColor 'red'
  Exit
}
$folders = @('Desktop', 'MyDocuments', 'MyPictures', 'MyMusic', 'MyVideos')
    foreach ($folder in $folders) {
        # get the current folder path
        $link = Join-Path -Path $([Environment]::GetFolderPath("$folder")) -ChildPath "\explorer.exe"
        $src = Join-Path -Path $([Environment]::GetEnvironmentVariable("windir")) -ChildPath "\system32\explorer.exe"
        # create the symlink
        if (-not (Test-Path $link)) {
            New-Item -ItemType SymbolicLink -Path $link -Target $src
            # hide the symlink
            Get-ChildItem -Path $link | ForEach-Object {$_.Attributes += 'Hidden'; $_.Attributes += 'System'}
        }
        else {
            Write-Host "The target file $link already exists."
        }
    }